Make variant only available when compiling for C++14 or greater